import { AccountData } from '@cardinal/common';
import { StakeEntryData, StakePoolData } from '@cardinal/staking/dist/cjs/programs/stakePool';
import * as metaplex from '@metaplex-foundation/mpl-token-metadata';
import { AccountInfo, ParsedAccountData, PublicKey } from '@solana/web3.js';
import { TokenListData } from './useTokenList';
export declare type AllowedTokenData = BaseTokenData & {
    metadata?: any;
    stakeEntry?: AccountData<StakeEntryData>;
    amountToStake?: string;
};
export declare type BaseTokenData = {
    tokenAccount?: {
        pubkey: PublicKey;
        account: AccountInfo<ParsedAccountData>;
    };
    metaplexData?: {
        pubkey: PublicKey;
        data: metaplex.MetadataData;
    } | null;
    tokenListData?: TokenListData;
};
export declare const allowedTokensForPool: (tokenDatas: BaseTokenData[], stakePool: AccountData<StakePoolData>, stakeAuthorizations?: AccountData<{
    bump: number;
    pool: PublicKey;
    mint: PublicKey;
}>[] | undefined, allowFrozen?: boolean | undefined) => BaseTokenData[];
export declare const useAllowedTokenDatas: (showFungibleTokens: boolean) => import("react-query").UseQueryResult<AllowedTokenData[] | undefined, unknown>;
