import { Cluster, Connection } from '@solana/web3.js';
import { NextPageContext } from 'next';
import React from 'react';
export interface Environment {
    label: Cluster;
    primary: string;
    secondary?: string;
}
export interface EnvironmentContextValues {
    environment: Environment;
    setEnvironment: (newEnvironment: Environment) => void;
    connection: Connection;
    secondaryConnection: Connection;
}
export declare const ENVIRONMENTS: Environment[];
export declare const getInitialProps: ({ ctx, }: {
    ctx: NextPageContext;
}) => Promise<{
    cluster: string;
}>;
export declare function EnvironmentProvider({ children, defaultCluster, query, }: {
    children: React.ReactChild;
    defaultCluster: string;
    query: {
        project?: string;
        host?: string;
        cluster?: string;
    };
}): JSX.Element;
export declare function useEnvironmentCtx(): EnvironmentContextValues;
