/// <reference types="bn.js" />
import { AccountData } from '@cardinal/common';
import { StakePoolData } from '@cardinal/staking/dist/cjs/programs/stakePool';
import { Connection, PublicKey } from '@solana/web3.js';
export declare const getStakePoolsByAuthority: (connection: Connection, user: PublicKey) => Promise<AccountData<StakePoolData>[]>;
export declare const useStakePoolsByAuthority: () => import("react-query").UseQueryResult<AccountData<{
    identifier: import("bn.js");
    bump: number;
    authority: PublicKey;
    requiresCreators: PublicKey[];
    requiresCollections: PublicKey[];
    requiresAuthorization: boolean;
    overlayText: string;
    imageUri: string;
    resetOnStake: boolean;
    totalStaked: number;
    cooldownSeconds: number | null;
    minStakeSeconds: number | null;
}>[] | undefined, unknown>;
