import { Connection, PublicKey } from '@solana/web3.js';
import { AccountData } from '@cardinal/stake-pool';
import * as metaplex from '@metaplex-foundation/mpl-token-metadata';
import { StakeEntryData } from '@cardinal/staking/dist/cjs/programs/stakePool';
import { TokenListData } from './useTokenList';
export declare type StakeEntryTokenData = {
    tokenListData?: TokenListData;
    metaplexData?: {
        pubkey: PublicKey;
        data: metaplex.MetadataData;
    } | null;
    metadata?: {
        pubkey: PublicKey;
        data: any;
    } | undefined | null;
    stakeEntry: AccountData<StakeEntryData> | null | undefined;
};
export declare function getStakeEntryDatas(connection: Connection, stakePoolId: PublicKey, userId: PublicKey): Promise<StakeEntryTokenData[]>;
export declare const useStakedTokenDatas: () => import("react-query").UseQueryResult<StakeEntryTokenData[] | undefined, unknown>;
